import java.io.*;

/**
 * 
 *
 * @author quasiyoke
 */
public class EasyReadingSolitaryFile extends EasyReadingFile{

private DataInputStream dataInput;

/**
 * @throws IOException Если файла нет.
 */
public EasyReadingSolitaryFile(String filePath) throws
	IOException{
    try{
	dataInput=new DataInputStream(PieceOfDictionary.getInstance().getClass().
		getResourceAsStream(filePath));
    }catch(NullPointerException e){
	throw new IOException();
    }
}

public void close() throws IOException{
    dataInput.close();
}

public char readChar() throws IOException{
    char result;
    try{
	result=dataInput.readChar();
    }catch(NullPointerException e){
	throw new IOException();
    }
    filePointer+=2;
    return result;
}

public int readInt() throws IOException{
    int result;
    try{
	result=dataInput.readInt();
    }catch(NullPointerException e){
	throw new IOException();
    }
    filePointer+=4;
    return result;
}

public int readUnsignedByte() throws IOException{
    int result;
    try{
	result=dataInput.readUnsignedByte();
    }catch(NullPointerException e){
	throw new IOException();
    }
    filePointer++;
    return result;
}

public EasyReadingFile seek(long position) throws IOException{
    if(position!=filePointer)
	if(position<filePointer){
	    dataInput.reset();
	    filePointer=dataInput.skip(position);
	}else
	    skipBytes((int)(position-filePointer));
    return this;
}

public EasyReadingFile skipBytes(int bytesCount) throws IOException{
    dataInput.skip(bytesCount);
    filePointer+=bytesCount;
    return this;
}

}
